routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

/*Route::get('/', function () {
    return view('welcome');
});*/

Auth::routes(['verify' => true]);

/* landing page */
Route::get('/', 'MainController@index')->name('main');
Route::get('/news', 'NewsController@index')->name('news');
Route::get('/about', 'MainController@about')->name('about');
Route::get('/faq', 'MainController@faq')->name('faq');

/*Admin page*/
Route::get('/admin', 'Admin\AdminController@index')->name('admin')->middleware('auth', 'checkadmin');
Route::get('/admin/user', 'Admin\UserController@index')->name('admin-user')->middleware('auth', 'checkadmin');
Route::get('/admin/user/review/{id}', 'Admin\UserController@show')->where('id', '[0-9]+')->name('admin-user-review')->middleware('auth', 'checkadmin');
Route::post('/admin/user/review/', 'Admin\UserController@verification')->name('admin-user-verification')->middleware('auth', 'checkadmin');
Route::get('/admin/jasa', 'Admin\JasaController@index')->name('admin-jasa')->middleware('auth', 'checkadmin');
Route::get('/admin/jasa/review/{id}', 'Admin\JasaController@review')->where('id', '[0-9]+')->name('admin-jasa-review')->middleware('auth', 'checkadmin');
Route::post('/admin/jasa/review/{id}', 'Admin\JasaController@reviewpost')->where('id', '[0-9]+')->name('admin-jasa-review-post')->middleware('auth', 'checkadmin');
Route::get('/admin/category', 'Admin\CategoryController@index')->name('admin-category')->middleware('auth', 'checkadmin');
Route::post('/admin/category', 'Admin\CategoryController@store')->name('admin-create-category')->middleware('auth', 'checkadmin');
Route::get('/admin/category/edit', 'Admin\CategoryController@edit')->name('admin-category-edit')->middleware('auth', 'checkadmin');
Route::post('/admin/category/edit', 'Admin\CategoryController@update')->name('admin-category-update')->middleware('auth', 'checkadmin');
Route::resource('/admin/adminpayment', 'Admin\PaymentController')->middleware(
    'auth', 'checkadmin'
);
Route::resource('/admin/site', 'Admin\SiteController')->middleware('auth', 'checkadmin');
Route::resource('/admin/hero/mitra', 'Admin\Hero\MitraController', ['as' => 'admin.hero'])->middleware('auth', 'checkadmin');
Route::resource('/admin/hero', 'Admin\HeroController', ['as' => 'admin'])->middleware('auth', 'checkadmin');

/* User */
Route::get('/user/profile', 'User\UserController@index')->name('user');
Route::post('/user/profile', 'User\UserController@update')->name('updateuser');
Route::post('/user/updatepp', 'User\UserController@updatepp')->name('updatepp');
Route::post('/user/updatepass', 'User\UserController@updatepass')->name('updatepass');
Route::get('/user/jasa', 'User\JasaController@index')->name('user-jasa')->middleware('checkidentitas');
Route::post('/user/jasa', 'User\JasaController@create')->name('user-create-jasa');
Route::post('/user/jasa/imgupload', 'User\JasaController@imgupload')->name('user-imgupload');
Route::get('/user/order', 'User\OrderController@show')->name('user-order')->middleware('auth');
Route::post('/user/order/konfirmasi', 'User\OrderController@confirm')->name('user-order-confirm')->middleware('auth');
Route::post('/user/order/cancel', 'User\OrderController@ordercancel')->name('user-order-cancel')->middleware('auth');
Route::resource('/user/hero', 'User\HeroController')->middleware('auth', 'verified');
Route::resource('/user/hero/customer', 'User\Hero\CustomerController', ['as' => 'hero'])->middleware('auth', 'verified');
Route::resource('/user/hero/mitra', 'User\Hero\MitraController', ['as' => 'hero'])->middleware('auth', 'verified');

/* Jasa */
Route::get('/jasa', 'Jasa\JasaController@index')->name('jasa');
Route::get('/jasa/c/{id}-{name}', 'Jasa\JasaController@index')->name('jasa-category')->where('id', '[0-9]+');
Route::get('/jasa/s/{id}-{name}', 'Jasa\JasaController@detail')->name('jasa-detail')->where('id', '[0-9]+');
Route::get('/jasa/o/{id?}-{name?}', 'Jasa\OrderController@index')->name('jasa-order')->where('id', '[0-9]+')->middleware('auth', 'checkalamat', 'checkidentitas');
Route::post('/jasa/o', 'Jasa\OrderController@store')->name('jasa-order-add')->where('id', '[0-9]+')->middleware('auth', 'checkalamat');
Route::get('/jasa/search/', 'Jasa\SearchController@show')->name('jasa-search');

/* Order */
Route::get('/order', 'Order\OrderController@index')->name('order')->middleware('checkjasa');
Route::post('/order/store', 'Order\OrderController@store')->name('order-store')->middleware('checkjasa');
Route::post('/order/done', 'Order\OrderController@done')->name('order-done')->middleware('checkjasa');
Route::resource('/order/userpayment', 'PaymentController');

/* Product */
//Route::post('/product/add', 'User\ProductController@store')->name('product-add');
Route::resource('product', 'User\ProductController');

/* Ajax */
Route::get('/ajax/address/provinsi/{id?}', 'Ajax\AddressController@provinsi')->name('ajax-address-provinsi');
Route::get('/ajax/address/kabkota/{id?}', 'Ajax\AddressController@kabkota')->name('ajax-address-kabkota');
Route::get('/ajax/address/kecamatan/{id?}', 'Ajax\AddressController@kecamatan')->name('ajax-address-kecamatan');
Route::post('/ajax/address/add', 'Ajax\AddressController@store')->name('ajax-address-store');
Route::resource('favorite', 'User\FavoriteController');

/*Gallery*/
Route::get('/gallery', 'Gallery\GalleryController@index')->name('gallery');

/*Notif*/
Route::get('pemberitahuan/read', 'Pemberitahuan\PemberitahuanController@read')->name('notifmarkasread')->middleware('auth');
Route::resource('pemberitahuan', 'Pemberitahuan\PemberitahuanController')->middleware('auth');

app/Http/Controllers/Admin/JasaController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Notifications\VerifyJasa;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Auth;
use App\Jasa;

class JasaController extends Controller
{
    //
    public function index()
    {
        //
        $user = Auth::user();
        $jasa = Jasa::with('user')->get();
        return view("admin.jasa.jasa", [
            'user' => $user,
            'jasaList' => $jasa
        ]);
    }

    public function review($id)
    {
        //
        $user = Auth::user();
        $jasa = Jasa::with('user')->where('id', $id)->first();
        if (isset($_GET['notif_id'])){
            $notifid = $_GET['notif_id'];
            $user->unreadNotifications->where('id', $notifid)->markAsRead();

            return redirect()->route('admin-jasa-review', ['id'=>$jasa])->with([
                'user' => $user,
                'jasa' => $jasa
            ]);
        }
        return view("admin.jasa.reviewjasa", [
            'user' => $user,
            'jasa' => $jasa
        ]);
    }

    public function reviewpost(Request $request, $id)
    {
        //
        $jasa = Jasa::with('user')->where('id', $id)->first();
        switch ($request->status) {
            case 1: // approve
                $jasa->verified = 1;
                $jasa->alasan = null;
                $jasa->save();
                $message = [
                    'subject' => 'Verifikasi Jasa',
                    'greeting' => 'Hi '.$jasa->user->name,
                    'body' => 'Verifikasi jasa anda telah berhasil. Silahkan klik dibawah untuk menuju halaman jasa anda',
                    'short' => 'Verifikasi jasa anda telah berhasil',
                    'thanks' => 'Terima Kasih.',
                    'actionText' => 'Buka Jasa',
                    'actionURL' => route('user-jasa'),
                ];
                $jasa->user->notify(new VerifyJasa($message));
                session()->flash('status', 'success');
                session()->flash('message', 'Approval <b>' . $jasa->name . '</b> sukses');
                return redirect()->route('admin-jasa');
                break;
            case 2: // ban
                $jasa->verified = 2;
                $jasa->save();
                $message = [
                    'subject' => 'Bantuin Jasa',
                    'greeting' => 'Hi '.$jasa->user->name,
                    'body' => 'Jasa anda telah di blokir oleh admin. Silahkan hubungi admin untuk informasi lebih lanjut',
                    'short' => 'Jasa anda telah di blokir oleh admin',
                    'thanks' => 'Terima Kasih.',
                    'actionText' => 'Buka Jasa',
                    'actionURL' => route('user-jasa'),
                ];
                $jasa->user->notify(new VerifyJasa($message));
                session()->flash('status', 'danger');
                session()->flash('message', 'Approval <b>' . $jasa->name . '</b> dicabut');
                return redirect()->route('admin-jasa');
                break;
            case 3: // tolak
                $jasa->verified = 3;
                $jasa->alasan = $request->alasan;
                $jasa->save();
                $message = [
                    'subject' => 'Verifikasi Jasa',
                    'greeting' => 'Hi '.$jasa->user->name,
                    'body' => "Verifikasi jasa anda ditolak oleh admin dengan alasan: <b>$request->alasan</b>. Silahkan klik dibawah untuk menuju halaman jasa anda",
                    'short' => "Verifikasi jasa anda ditolak oleh admin dengan alasan: <b>$request->alasan</b>",
                    'thanks' => 'Terima Kasih.',
                    'actionText' => 'Buka Jasa',
                    'actionURL' => route('user-jasa'),
                ];
                $jasa->user->notify(new VerifyJasa($message));
                session()->flash('status', 'danger');
                session()->flash('message', 'Pengajuan jasa <b>' . $jasa->name . '</b> ditolak');
                return redirect()->route('admin-jasa');
                break;
            case 4: // cancel
                session()->flash('status', 'danger');
                session()->flash('message', 'Approval <b>' . $jasa->name . '</b> dibatalkan');
                return redirect()->route('admin-jasa');
                break;
            default:
                break;
        }
    }
}

app/Http/Controllers/Jasa/JasaController.php
<?php

namespace App\Http\Controllers\Jasa;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Auth;
use App\Jasa;
use App\Category;
use App\Product;

class JasaController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index($id = null, $name = null)
    {
//
        $user = Auth::user();
        $jasa = Jasa::all();
        $parent = Category::whereNull('parent_id')->get();
        if (isset($id) && isset($name)) {
            $product = Product::whereHas('jasa')->where([
                ['category_id', $id],
                ['status', '<>', 4]
            ])->paginate(8);
        } else {
            $product = Product::whereHas('jasa')->where('status', '<>', '4')->paginate(8);
        }
        return view('jasa.index', [
            'user' => $user,
            'jasaList' => $jasa,
            'parents' => $parent,
            'productList' => $product
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
//
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
//
    }

    /**
     * Display the specified resource.
     *
     * @param \App\Jasa $jasa
     * @return \Illuminate\Http\Response
     */
    public function show(Jasa $jasa)
    {

    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param \App\Jasa $jasa
     * @return \Illuminate\Http\Response
     */
    public function edit(Jasa $jasa)
    {
//
    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param \App\Jasa $jasa
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Jasa $jasa)
    {
//
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param \App\Jasa $jasa
     * @return \Illuminate\Http\Response
     */
    public function destroy(Jasa $jasa)
    {
//
    }

    public function detail($id, $name)
    {
//
        $user = Auth::user();
        $product = Product::find($id);
        if ($product->status != 4){
            return view('jasa.product', [
                'user' => $user,
                'product' => $product
            ]);
        }
        else{
            return redirect()->route('jasa')->with('error', 'Terjadi kesalahan pada sistem. Silahkan ulangi beberapa saat lagi.');
        }
    }
}

app/Http/Controllers/Jasa/OrderController.php
<?php

namespace App\Http\Controllers\Jasa;

use App\Notifications\OrderNotification;
use App\Order;
use App\Product;
use Carbon\Carbon;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Auth;

class OrderController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @param $id
     * @return \Illuminate\Http\Response
     */
    public function index($id)
    {
        //
        $user = Auth::user();
        $product = Product::find($id);
        if ($product->status != 4) {
            if ($product->jasa->user->id == Auth::id()) {
                return redirect()->route('jasa-detail', [
                    'id' => $id,
                    'name' => str_replace(' ', '-', $product->name)
                ]);
            }
            return view('jasa.order', [
                'user' => $user,
                'product' => $product
            ]);
        }
        else{
            return redirect()->route('jasa')->with('error', 'Terjadi kesalahan pada sistem. Silahkan ulangi beberapa saat lagi.');
        }
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $order = new Order;
        $order->products_id = $request->products_id;
        $order->ref = "B".Carbon::now()->format('dmy').str_pad(Auth::id(),3,"000", STR_PAD_LEFT).str_pad(count(Order::whereDate('created_at', Carbon::today())->get()) + 1, 3, "000", STR_PAD_LEFT);
        $order->user_id = Auth::id();
        if ($request->has('note')){
            $order->note = $request->note;
        }
        $order->status = 1;
        $order->save();
        $message = [
            'type' => 1,
            'subject' => 'Pesanan Jasa Baru',
            'greeting' => 'Hi '.$order->product->jasa->user->name,
            'body' => 'Anda mendapat pesanan jasa baru. Silahkan klik dibawah untuk menuju halaman pesanan jasa',
            'short' => 'Anda mendapat pesanan jasa baru',
            'thanks' => 'Terima Kasih.',
            'actionText' => 'Buka Pesanan',
            'actionURL' => route('order'),
        ];
        $order->product->jasa->user->notify(new OrderNotification($message));
        return redirect()->route('user-order');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Order  $order
     * @return \Illuminate\Http\Response
     */
    public function show(Order $order)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Order  $order
     * @return \Illuminate\Http\Response
     */
    public function edit(Order $order)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Order  $order
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Order $order)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Order  $order
     * @return \Illuminate\Http\Response
     */
    public function destroy(Order $order)
    {
        //
    }
}

app/Http/Controllers/Jasa/SearchController.php
<?php

namespace App\Http\Controllers\Jasa;

use App\Category;
use App\Jasa;
use App\Product;
use Auth;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class SearchController extends Controller
{
    //
    public function show(Request $request){
        $product = Product::query()->where([
            ['name', 'LIKE', "%{$request->input('q')}%"],
            ['status', '<>', '4']
        ])->paginate(8);
        $user = Auth::user();
        $jasa = Jasa::all();
        $parent = Category::whereNull('parent_id')->get();
        return view('jasa.index', [
            'user' => $user,
            'jasaList' => $jasa,
            'parents' => $parent,
            'productList' => $product,
            'q' => $request->input('q')
        ]);
    }
}

resources/views/jasa/index.blade.php
@extends('layouts.main')
@section('title', '| Jasa')
@section('content')
    <section class="cat_product_area section_gap">
        <div class="container-fluid">
            <div class="row flex-row-reverse">
                <div class="col-lg-9">
                    <div class="latest_product_inner row">
                        @if($productList->count())
                            @if(isset($q))
                                <div class="col-lg-12">
                                    <div class="alert alert-info text-center" role="alert">
                                        <h5>Cari Jasa: "{{ $q }}"</h5>
                                    </div>
                                </div>
                            @endif
                            @foreach ($productList as $product)
                                <div class="col-lg-3 col-md-3 col-sm-6">
                                    <div class="f_p_item">
                                        <div class="f_p_img">
                                            @php
                                                $images = explode("|", $product->image);
                                            @endphp
                                            <img class="img-fluid"
                                                 src="{{ asset("storage/images/product/").'/'.$images[0]}}" alt="">
                                            <div class="p_icon">
                                                @auth
                                                    <a href="#">
                                                        <i class="{{ in_array($product->id, $user->favorite->pluck('products_id')->toArray()) ? 'fas fa-heart' : 'far fa-heart' }}" aria-hidden="true" data-id="{{ $product->id }}"></i>
                                                    </a>
                                                @endauth
                                                <a href="{{ route('jasa-detail', ['id' => $product->id, 'name' => urlencode(str_replace(' ', '-', $product->name))]) }}">
                                                    <i class="lnr lnr-cart"></i>
                                                </a>
                                            </div>
                                        </div>
                                        <a href="{{ route('jasa-detail', ['id' => $product->id, 'name' => urlencode(str_replace(' ', '-', $product->name))]) }}">
                                            <h4>{{ $product->name }}</h4>
                                        </a>
                                        <ul class="list">
                                            <li>
                                                @php
                                                    $rate = round($product->rating->avg('rating'));
                                                    for ($x = 0; $x < $rate; $x++) {
                                                        echo '<i class="fas fa-star" style="color: #f47321"></i>';
                                                    }
                                                    for ($x = 0; $x < 5-$rate; $x++) {
                                                        echo '<i class="far fa-star"></i>';
                                                    }
                                                @endphp
                                                ({{ round($product->rating->avg('rating')) }})
                                            </li>
                                        </ul>
                                        <h5>Rp. {{ number_format($product->price,0,',','.') }}</h5>
                                    </div>
                                </div>
                            @endforeach
                        @else
                            @if(count(\App\Jasa::all()) > 0)
                            <div class="col-lg-12">
                                <div class="alert alert-danger text-center" role="alert">
                                    <h5>Jasa tidak ditemukan</h5>
                                </div>
                            </div>
                                @else
                                <div class="col-lg-12">
                                    <div class="alert alert-danger text-center" role="alert">
                                        <h5>Belum ada jasa yang didaftarkan</h5>
                                    </div>
                                </div>
                                @endif
                        @endif
                        @if(session('error'))
                            <div class="col-lg-12">
                                <div class="alert alert-danger text-center" role="alert">
                                    <h5>{{ session('error') }}</h5>
                                </div>
                            </div>
                        @endif
                    </div>
                </div>
                <div class="col-lg-3">
                    <div class="left_sidebar_area">
                        <aside class="left_widgets cat_widgets">
                            <div class="l_w_title">
                                <h3>Browse Categories</h3>
                            </div>
                            <div class="widgets_inner">
                                <ul class="list">
                                    @foreach ($parents as $parent)
                                        <li>
                                            <a href="#{{ $parent->id }}" class="caret">{{ $parent->name }} <i
                                                        class="fa fa-plus" style="float: right"></i></a>
                                            @if ($parent->children->count())
                                                <ul class="list">
                                                    @foreach($parent->children as $children)
                                                        <li>
                                                            <a href="{{ route('jasa-category', ['id' => $children->id, 'name' => str_replace(" ", "-", $children->name)]) }} ">{{ $children->name }}</a>
                                                        </li>
                                                    @endforeach
                                                </ul>
                                            @endif
                                        </li>
                                    @endforeach
                                </ul>
                            </div>
                        </aside>{{--
                        <aside class="left_widgets p_filter_widgets">
                            <div class="widgets_inner">
                                <h4>Price</h4>
                                <div class="range_item">
                                    <div id="slider-range"></div>
                                    <div class="row m0">
                                        <label for="amount">Price : </label>
                                        <input type="text" id="amount" readonly>
                                    </div>
                                </div>
                            </div>
                        </aside>--}}
                    </div>
                </div>
            </div>
            <div class="row">
                <nav class="cat_page mx-auto" aria-label="Page navigation example">
                    {{ $productList->links() }}
                </nav>
            </div>
        </div>
    </section>
@endsection
@section('customjs')
    <script type="text/javascript">
        $(document).ready(function () {
            $(".p_icon").click(function () {
                var iconheart = $(this).find(".fa-heart");
                $.ajax({
                    url: '{{ route('favorite.store') }}',
                    method: "POST",
                    data: { id: iconheart.data("id") },
                    dataType: 'JSON',
                    headers: {
                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                    },
                    success: function (data) {
                        if (data.status === 1) {
                            iconheart.toggleClass('fas fa-heart');
                            iconheart.toggleClass('far fa-heart');
                        }
                    }
                });

            })
        });
    </script>
@endsection

resources/views/jasa/order.blade.php
@extends('layouts.main')
@section('title', '| Order Jasa')
@section('content')
    <section class="checkout_area section_gap">
        <div class="container">
            <div class="d-flex justify-content-center">
                <div class="col-lg-6">
                    <div class="order_box">
                        <h2>Pesan Jasa</h2>
                        <label for="note">Masukkan catatan pesanan untuk penyedia jasa (opsional)</label>
                        <form action="{{route('jasa-order-add')}}" method="POST">
                        <textarea name="note" class="form-control" id="note" placeholder="Masukkan catatan pesanan"></textarea>
                        <ul class="list">
                            <li>
                                <a>Nama Jasa
                                    <span>Biaya Jasa</span>
                                </a>
                            </li>
                            <li>
                                <a>{{ $product->name  }}
                                    <span class="last">Rp. {{ number_format($product->price, 0, ',', '.') }}</span>
                                </a>
                            </li>
                        </ul>
                        <ul class="list list_2">
                            <li>
                                <a>Total
                                    <span>Rp. {{ number_format($product->price, 0, ',', '.') }}</span>
                                </a>
                            </li>
                        </ul>
                            @csrf
                            <label>
                                <input type="text" value="{{ $product->id }}" name="products_id" hidden>
                            </label>
                            <div class="d-flex justify-content-center">
                                <button type="submit" class="main_btn" href="#">Pesan Jasa</button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </section>
@endsection